Measure Ruler in JavaScript

Using ApexCharts with JavaScript

This Measure Ruler example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
function series() {
  var out = []
  var v = 100
  for (var i = 0; i < 60; i++) {
    v += 2 + Math.sin(i / 5) * 3
    out.push([i, Math.round(v)])
  }
  return out
}

var options = {
  series: [{ name: 'Price', data: series() }],
  chart: {
    id: 'price',
    type: 'area',
    height: 380,
    fontFamily: 'Helvetica, Arial, sans-serif',
    animations: { enabled: false },
    measure: { enabled: true, pinOnRelease: true },
    toolbar: { show: true, autoSelected: 'measure' },
    zoom: { enabled: true, type: 'x' },
  },
  stroke: { width: 2, curve: 'straight' },
  dataLabels: { enabled: false },
  title: { text: 'Price (measure any move)', align: 'left' },
  xaxis: { type: 'numeric', title: { text: 'Session' } },
  yaxis: { title: { text: 'Price' }, decimalsInFloat: 0 },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

// The ruler tool is pre-selected via toolbar.autoSelected: 'measure', so the
// plot is already armed on load -- just drag. The toolbar icon toggles it (and
// the 'm' key still works); no custom wiring needed here.
var readout = document.getElementById('mz-readout')

document.getElementById('mz-clear').addEventListener('click', function () {
  chart.clearMeasures()
})

chart.addEventListener('measured', function (c, o) {
  readout.textContent =
    'dx=' +
    Number(o.dx).toFixed(2) +
    '  dy=' +
    Number(o.dy).toFixed(2) +
    '  (' +
    (o.percentChange >= 0 ? '+' : '') +
    Number(o.percentChange).toFixed(1) +
    '%)'
})

Measure Ruler in Vue

Using ApexCharts with Vue

This Measure Ruler example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="mz-wrap">
      <div class="mz-bar">
        <button id="mz-clear">Clear</button>
        <span class="readout" id="mz-readout"
          >The ruler tool is pre-selected in the toolbar. Drag from A to B on
          the chart.</span
        >
      </div>

      <div id="chart">
        <apexchart
          type="area"
          height="380"
          :options="chartOptions"
          :series="series"
        ></apexchart>
      </div>

      <div class="mz-note">
        The ruler is a built-in <b>toolbar tool</b>, pre-selected here with
        <code>toolbar.autoSelected: 'measure'</code>. Drag across the plot: a
        shaded band spans the two points and a readout shows the <b>change</b>,
        the <b>% change</b> and the <b>range</b> between them, with the
        endpoints snapped to the price line (the finance-style default,
        <code>measure.mode: 'span'</code>). Green means the move is up, red
        means down. Release to pin it; a pinned ruler is stored in data
        coordinates, so it stays glued when you zoom or resize. Click the ruler
        icon again to deselect it and hand the plot back to zoom; the
        <code>m</code> key still works too. Fires the
        <code>measured</code> event. Set <code>measure.mode: 'free'</code> for a
        diagonal ruler between any two points. Needs the
        <code>measure</code> feature. <b>Clear</b> removes all rulers.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

import 'apexcharts/features/history'
import 'apexcharts/features/perspectives'
import 'apexcharts/features/measure'

function series() {
  var out = []
  var v = 100
  for (var i = 0; i < 60; i++) {
    v += 2 + Math.sin(i / 5) * 3
    out.push([i, Math.round(v)])
  }
  return out
}

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [
  { name: 'Price', data: series() }
],
chartOptions: {
chart: {
  id: 'price',
  type: 'area',
  height: 380,
  fontFamily: 'Helvetica, Arial, sans-serif',
  animations: { enabled: false },
  measure: { enabled: true, pinOnRelease: true },
  toolbar: { show: true, autoSelected: 'measure' },
  zoom: { enabled: true, type: 'x' },
},
stroke: { width: 2, curve: 'straight' },
dataLabels: { enabled: false },
title: { text: 'Price (measure any move)', align: 'left' },
xaxis: { type: 'numeric', title: { text: 'Session' } },
yaxis: { title: { text: 'Price' }, decimalsInFloat: 0 },
},
pollTimer: null,
}
},
mounted: function () {
  // The vue-apexcharts wrapper owns the render, so reach the live instance by
  // its chart.id, then wire the same handlers the vanilla build does.
  // (series() lives in the shared head script.)
  var me = this
  me.pollTimer = window.setInterval(function () {
    var chart = ApexCharts.getChartByID('price')
    if (!chart) return
    window.clearInterval(me.pollTimer)
    me.pollTimer = null

    var readout = document.getElementById('mz-readout')

    document.getElementById('mz-clear').addEventListener('click', function () {
      chart.clearMeasures()
    })

    chart.addEventListener('measured', function (c, o) {
      readout.textContent =
        'dx=' + Number(o.dx).toFixed(2) +
        '  dy=' + Number(o.dy).toFixed(2) +
        '  (' + (o.percentChange >= 0 ? '+' : '') + Number(o.percentChange).toFixed(1) + '%)'
    })
  }, 50)
},
beforeDestroy: function () {
  if (this.pollTimer) window.clearInterval(this.pollTimer)
},,
}
</script>

<style>
.mz-wrap {
  max-width: 820px;
  margin: 12px auto;
  font-family: Helvetica, Arial, sans-serif;
}
.mz-bar {
  display: flex;
  gap: 10px;
  align-items: center;
  flex-wrap: wrap;
  margin: 4px 6px 10px;
}
.mz-bar button {
  padding: 6px 13px;
  cursor: pointer;
  border: 1px solid #0ea5e9;
  color: #0369a1;
  background: #fff;
  border-radius: 6px;
  font-size: 13px;
  font-weight: 600;
}
.mz-bar button.active {
  background: #0ea5e9;
  color: #fff;
}
.mz-bar .readout {
  font-family: monospace;
  font-size: 13px;
  color: #445;
}
.mz-note {
  background: #f0f9ff;
  border-left: 3px solid #0ea5e9;
  padding: 11px 15px;
  font-size: 13px;
  color: #234;
  border-radius: 2px;
  line-height: 1.6;
  margin: 12px 6px;
}
.mz-note code {
  background: #dceafb;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>

Measure Ruler in React

Using ApexCharts with React

This Measure Ruler example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

import 'apexcharts/features/history'
import 'apexcharts/features/perspectives'
import 'apexcharts/features/measure'

function series() {
  var out = []
  var v = 100
  for (var i = 0; i < 60; i++) {
    v += 2 + Math.sin(i / 5) * 3
    out.push([i, Math.round(v)])
  }
  return out
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [{ name: 'Price', data: series() }],
    options: {
      chart: {
        id: 'price',
        type: 'area',
        height: 380,
        fontFamily: 'Helvetica, Arial, sans-serif',
        animations: { enabled: false },
        measure: { enabled: true, pinOnRelease: true },
        toolbar: { show: true, autoSelected: 'measure' },
        zoom: { enabled: true, type: 'x' },
      },
      stroke: { width: 2, curve: 'straight' },
      dataLabels: { enabled: false },
      title: { text: 'Price (measure any move)', align: 'left' },
      xaxis: { type: 'numeric', title: { text: 'Session' } },
      yaxis: { title: { text: 'Price' }, decimalsInFloat: 0 },
    },
  })

  React.useEffect(() => {
    // The ruler tool is pre-selected via toolbar.autoSelected: 'measure', so the
    // plot is armed on load. The react-apexcharts wrapper owns the render, so
    // reach the live instance by its chart.id, then wire the same handlers the
    // vanilla build does. (series() lives in the shared head script.)
    let chart
    const timer = window.setInterval(() => {
      chart = ApexCharts.getChartByID('price')
      if (!chart) return
      window.clearInterval(timer)

      const readout = document.getElementById('mz-readout')

      document.getElementById('mz-clear').addEventListener('click', () => {
        chart.clearMeasures()
      })

      chart.addEventListener('measured', (c, o) => {
        readout.textContent =
          'dx=' +
          Number(o.dx).toFixed(2) +
          '  dy=' +
          Number(o.dy).toFixed(2) +
          '  (' +
          (o.percentChange >= 0 ? '+' : '') +
          Number(o.percentChange).toFixed(1) +
          '%)'
      })
    }, 50)

    return () => window.clearInterval(timer)
  }, [])

  return (
    <div>
      <div className="mz-wrap">
        <div className="mz-bar">
          <button id="mz-clear">Clear</button>
          <span className="readout" id="mz-readout">
            The ruler tool is pre-selected in the toolbar. Drag from A to B on
            the chart.
          </span>
        </div>

        <div id="chart">
          <ReactApexChart
            options={state.options}
            series={state.series}
            type="area"
            height={380}
          />
        </div>

        <div className="mz-note">
          The ruler is a built-in <b>toolbar tool</b>, pre-selected here with
          <code>toolbar.autoSelected: 'measure'</code>. Drag across the plot: a
          shaded band spans the two points and a readout shows the <b>change</b>
          , the
          <b>% change</b> and the <b>range</b> between them, with the endpoints
          snapped to the price line (the finance-style default,{' '}
          <code>measure.mode: 'span'</code>). Green means the move is up, red
          means down. Release to pin it; a pinned ruler is stored in data
          coordinates, so it stays glued when you zoom or resize. Click the
          ruler icon again to deselect it and hand the plot back to zoom; the
          <code>m</code> key still works too. Fires the <code>measured</code>{' '}
          event. Set
          <code>measure.mode: 'free'</code> for a diagonal ruler between any two
          points. Needs the <code>measure</code> feature. <b>Clear</b> removes
          all rulers.
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Measure Ruler in Angular

Using ApexCharts with Angular

This Measure Ruler example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private series = (): any => {
        var out = []
        var v = 100
        for (var i = 0; i < 60; i++) {
          v += 2 + Math.sin(i / 5) * 3
          out.push([i, Math.round(v)])
        }
        return out
      };

  private readout: any = document.getElementById('mz-readout');

  public chartOptions: Partial<ChartOptions> = {
          series: [{ name: 'Price', data: this.series() }],
          chart: {
            id: 'price',
            type: 'area',
            height: 380,
            fontFamily: 'Helvetica, Arial, sans-serif',
            animations: { enabled: false },
            measure: { enabled: true, pinOnRelease: true },
            toolbar: { show: true, autoSelected: 'measure' },
            zoom: { enabled: true, type: 'x' },
          },
          stroke: { width: 2, curve: 'straight' },
          dataLabels: { enabled: false },
          title: { text: 'Price (measure any move)', align: 'left' },
          xaxis: { type: 'numeric', title: { text: 'Session' } },
          yaxis: { title: { text: 'Price' }, decimalsInFloat: 0 },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');

    document.getElementById('mz-clear').addEventListener('click', () => {
            this.chart.clearMeasures()
          })
    this.chart.addEventListener('measured', (c, o) => {
            this.readout.textContent =
              'dx=' +
              Number(o.dx).toFixed(2) +
              '  dy=' +
              Number(o.dy).toFixed(2) +
              '  (' +
              (o.percentChange >= 0 ? '+' : '') +
              Number(o.percentChange).toFixed(1) +
              '%)'
          })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}